procedure Rectangle.SetColour(Pos: DWord; R, G, B, A: Int64);
var
    c: Int64;
    d: Int64;
    Position: Vertex;
    
begin
	Position := DWordToVertex(Pos);

    if (Position[1] = -1) and (Position[2] = -1) then
	begin
	    c := 0;
	    repeat
		c := c + 1;
		
		d := 0;
		repeat
		    d := d + 1;
		    
		    VertexColour[c,d,1] := R;
		    VertexColour[c,d,2] := G;
		    VertexColour[c,d,3] := B;
		    VertexColour[c,d,4] := A;
		    until d = 2;
		until (c = 2) and (d = 2);
	end
    else
	begin
	    VertexColour[Position[1],Position[2],1] := R;
	    VertexColour[Position[1],Position[2],2] := G;
	    VertexColour[Position[1],Position[2],3] := B;
	    VertexColour[Position[1],Position[2],4] := A;
	end;
end;

procedure Rectangle.SetDimensions(X, Y: Int64);
begin
    Width := X;
    Height := Y;
end;

procedure Rectangle.Draw(X, Y: Int64);
begin
    glBindTexture( GL_TEXTURE_2D, PrometheusVideo.GlVRam );
 
    glBegin( GL_QUADS );
	    glColor4f( VertexColour[1,1,1] / 255, VertexColour[1,1,2] / 255, VertexColour[1,1,3] / 255, VertexColour[1,1,4] / 255);
	    glTexCoord2i( 0, 0 );
	    glVertex2f( X, Y);
	    
	    glColor4f( VertexColour[2,1,1] / 255, VertexColour[2,1,2] / 255, VertexColour[2,1,3] / 255, VertexColour[2,1,4] / 255);
	    glTexCoord2i( 1, 0 );
	    glVertex2f( X + Width, Y);
	    
	    glColor4f( VertexColour[2,2,1] / 255, VertexColour[2,2,2] / 255, VertexColour[2,2,3] / 255, VertexColour[2,2,4] / 255);
	    glTexCoord2i( 1, 1 );
	    glVertex2f( X + Width, Y + Height);
	    
	    glColor4f( VertexColour[1,2,1] / 255, VertexColour[1,2,2] / 255, VertexColour[1,2,3] / 255, VertexColour[1,2,4] / 255);
	    glTexCoord2i( 0, 1 );
	    glVertex2f( X, Y + Height);
    glEnd();
    
    glDeleteTextures( 1, @PrometheusVideo.GlVRam );
end;

procedure Rectangle.SetDrawMode(Mode: DWord);
begin
    if Mode = Centre then
	begin
	    DrawOffSet.X := Width div 2;
	    DrawOffset.Y := Height div 2;
	end;
    if Mode = UpperLeft then
	begin
	    DrawOffset.X := 0;
	    DrawOffset.Y := 0;
	end;
	if Mode = UpperRight then
	begin
		DrawOffset.X := Width;
		DrawOffset.Y := 0;
	end;
	if Mode = LowerLeft then
	begin
		DrawOffset.X := 0;
		DrawOffset.Y := Height;
	end;
	if Mode = LowerRight then
	begin
		DrawOffset.X := Width;
		DrawOffset.Y := Height;
	end;
end;

procedure Square.SetDrawMode(Mode: DWord);
begin
    if Mode = Centre then
	begin
	    DrawOffSet.X := Length div 2;
	    DrawOffset.Y := Length div 2;
	end;
    if Mode = UpperLeft then
	begin
	    DrawOffset.X := 0;
	    DrawOffset.Y := 0;
	end;
	if Mode = UpperRight then
	begin
		DrawOffset.X := Length;
		DrawOffset.Y := 0;
	end;
	if Mode = LowerLeft then
	begin
		DrawOffset.X := 0;
		DrawOffset.Y := Length;
	end;
	if Mode = LowerRight then
	begin
		DrawOffset.X := Length;
		DrawOffset.Y := Length;
	end;
end;

procedure Square.SetColour(Pos: DWord; R, G, B, A: Int64);
var
    c: Int64;
    d: Int64;
    Position: Vertex;
    
begin
	Position := DWordToVertex(Pos);

    if (Position[1] = -1) and (Position[2] = -1) then
	begin
	    c := 0;
	    repeat
		c := c + 1;
		
		d := 0;
		repeat
		    d := d + 1;
		    
		    VertexColour[c,d,1] := R;
		    VertexColour[c,d,2] := G;
		    VertexColour[c,d,3] := B;
		    VertexColour[c,d,4] := A;
		    until d = 2;
		until (c = 2) and (d = 2);
	end
    else
	begin
	    VertexColour[Position[1],Position[2],1] := R;
	    VertexColour[Position[1],Position[2],2] := G;
	    VertexColour[Position[1],Position[2],3] := B;
	    VertexColour[Position[1],Position[2],4] := A;
	end;
end;

procedure Square.SetLength(L: Int64);
begin
    Length := L;
end;

procedure Square.Draw(X, Y: Int64);
begin
    glBindTexture( GL_TEXTURE_2D, PrometheusVideo.GlVRam );
 
    glBegin( GL_QUADS );
	    glColor4f( VertexColour[1,1,1] / 255, VertexColour[1,1,2] / 255, VertexColour[1,1,3] / 255, VertexColour[1,1,4] / 255);
	    glTexCoord2i( 0, 0 );
	    glVertex2f( X, Y);
	    
	    glColor4f( VertexColour[2,1,1] / 255, VertexColour[2,1,2] / 255, VertexColour[2,1,3] / 255, VertexColour[2,1,4] / 255);
	    glTexCoord2i( 1, 0 );
	    glVertex2f( X + Length, Y);
	    
	    glColor4f( VertexColour[2,2,1] / 255, VertexColour[2,2,2] / 255, VertexColour[2,2,3] / 255, VertexColour[2,2,4] / 255);
	    glTexCoord2i( 1, 1 );
	    glVertex2f( X + Length, Y + Length);
	    
	    glColor4f( VertexColour[1,2,1] / 255, VertexColour[1,2,2] / 255, VertexColour[1,2,3] / 255, VertexColour[1,2,4] / 255);
	    glTexCoord2i( 0, 1 );
	    glVertex2f( X, Y + Length);
    glEnd();
    
    glDeleteTextures( 1, @PrometheusVideo.GlVRam );
end;
